summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
author Mario Preksavec <mario at slackware dot hr>2019-05-18 06:55:47 +0700
committer Willy Sudiarto Raharjo <willysr@slackbuilds.org>2019-05-18 06:55:47 +0700
commit1599e63a2dd35c9b2e14dce34ed67dee4b404522 (patch)
tree0ca0f6827d49d99c6623ce4a081a2782dd6be47a
parentcfdf1e2c64ae2f7820ae18cc85d051929fb74873 (diff)
downloadslackbuilds-1599e63a2dd35c9b2e14dce34ed67dee4b404522.tar.gz
slackbuilds-1599e63a2dd35c9b2e14dce34ed67dee4b404522.tar.xz
system/lvm2-lockd: Added (LVM in a shared storage environment).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
-rw-r--r--system/lvm2-lockd/README21
-rw-r--r--system/lvm2-lockd/README.SLACKWARE31
-rw-r--r--system/lvm2-lockd/doinst.sh26
-rw-r--r--system/lvm2-lockd/lvm2-lockd.SlackBuild141
-rw-r--r--system/lvm2-lockd/lvm2-lockd.info10
-rw-r--r--system/lvm2-lockd/slack-desc19
6 files changed, 248 insertions, 0 deletions
diff --git a/system/lvm2-lockd/README b/system/lvm2-lockd/README
new file mode 100644
index 0000000000..6b49d6c7a8
--- /dev/null
+++ b/system/lvm2-lockd/README
@@ -0,0 +1,21 @@
+Logical Volume Management (LVM) commands use lvmlockd to coordinate access
+to shared storage.
+
+NOTE: lvm2 package that comes with Slackware includes lvmlockd
+support. However, since neither sanlock or dlm were present at build time,
+empty functions were compiled in. In order for lvm commands (such as lvmcreate,
+etc) to discover and leverage lvmlockd support, stock lvm binary has to
+be replaced:
+
+ CLOBBER_STOCK_BINARY=yes ./lvm2-lockd.SlackBuild
+
+The original binary can be restored by reinstalling the stock lvm2 package.
+
+By default, lock type is set to sanlock, dlm can be selected with:
+
+ LOCK_TYPE=dlm ./lvm2-lockd.SlackBuild
+
+This will change package dependancy from sanlock to dlm (also found here
+on SlackBuilds.org).
+
+More information post-install can be found in README.SLACKWARE
diff --git a/system/lvm2-lockd/README.SLACKWARE b/system/lvm2-lockd/README.SLACKWARE
new file mode 100644
index 0000000000..5cd06a425c
--- /dev/null
+++ b/system/lvm2-lockd/README.SLACKWARE
@@ -0,0 +1,31 @@
+Starting the daemon on boot
+---------------------------
+
+You may wish to add these lines to /etc/rc.d/rc.local to start the service:
+
+ if [ -x /etc/rc.d/rc.lvmetad ]; then
+ /etc/rc.d/rc.lvmetad start
+ fi
+
+ if [ -x /etc/rc.d/rc.lvmlockd ]; then
+ /etc/rc.d/rc.lvmlockd start
+ fi
+
+You may also add these lines to /etc/rc.d/rc.local_shutdown:
+
+ if [ -x /etc/rc.d/rc.lvmlockd ]; then
+ /etc/rc.d/rc.lvmlockd stop
+ fi
+
+ if [ -x /etc/rc.d/rc.lvmetad ]; then
+ /etc/rc.d/rc.lvmetad stop
+ fi
+
+Remember to give executable permission to /etc/rc.d/rc.local_shutdown:
+
+ chmod 0755 /etc/rc.d/rc.local_shutdown
+
+Running the LVM locking system
+------------------------------
+
+Make sure to read USAGE section in lvmlockd man pages ;-)
diff --git a/system/lvm2-lockd/doinst.sh b/system/lvm2-lockd/doinst.sh
new file mode 100644
index 0000000000..2133933dde
--- /dev/null
+++ b/system/lvm2-lockd/doinst.sh
@@ -0,0 +1,26 @@
+config() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ # If there's no config file by that name, mv it over:
+ if [ ! -r $OLD ]; then
+ mv $NEW $OLD
+ elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
+ # toss the redundant copy
+ rm $NEW
+ fi
+ # Otherwise, we leave the .new copy for the admin to consider...
+}
+
+preserve_perms() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ if [ -e $OLD ]; then
+ cp -a $OLD ${NEW}.incoming
+ cat $NEW > ${NEW}.incoming
+ mv ${NEW}.incoming $NEW
+ fi
+ config $NEW
+}
+
+preserve_perms etc/rc.d/rc.lvmetad.new
+preserve_perms etc/rc.d/rc.lvmlockd.new
diff --git a/system/lvm2-lockd/lvm2-lockd.SlackBuild b/system/lvm2-lockd/lvm2-lockd.SlackBuild
new file mode 100644
index 0000000000..143390df28
--- /dev/null
+++ b/system/lvm2-lockd/lvm2-lockd.SlackBuild
@@ -0,0 +1,141 @@
+#!/bin/sh
+
+# Slackware build script for lvm2-lockd
+
+# Copyright 2019 Mario Preksavec, Zagreb, Croatia
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=lvm2-lockd
+VERSION=${VERSION:-2.02.154}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+SRCNAM=LVM2
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $SRCNAM.$VERSION
+tar xvf $CWD/$SRCNAM.$VERSION.tar.xz
+cd $SRCNAM.$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+# Copied from lvm2.SlackBuild
+CFLAGS="$SLKCFLAGS" \
+./configure \
+ --disable-readline \
+ --enable-cmdlib \
+ --enable-dmeventd \
+ --enable-applib \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --with-usrlibdir=/usr/lib${LIBDIRSUFFIX} \
+ --mandir=/usr/man \
+ --enable-realtime \
+ --with-lvm1=internal \
+ --enable-pkgconfig \
+ --enable-udev_sync \
+ --enable-udev_rules \
+ --with-udev-prefix="" \
+ --with-device-uid=0 \
+ --with-device-gid=6 \
+ --with-device-mode=0660 \
+ --with-default-locking-dir=/run/lock/lvm \
+ --with-default-run-dir=/run/lvm \
+ --with-default-dm-run-dir=/run/lvm \
+ --with-clvmd-pidfile=/run/lvm/clvmd.pid \
+ --with-cmirrord-pidfile=/run/lvm/cmirrord.pid \
+ --with-dmeventd-pidfile=/run/lvm/dmeventd.pid \
+ --enable-use-lvmlockd \
+ --enable-lockd-${LOCK_TYPE:-sanlock} \
+ --build=$ARCH-slackware-linux
+
+make daemons man tools
+
+# Some assembly required
+install -D -m0755 -oroot -groot daemons/lvmlockd/lvmlockd $PKG/usr/sbin/lvmlockd
+install -D -m0755 -oroot -groot daemons/lvmlockd/lvmlockctl $PKG/usr/sbin/lvmlockctl
+install -D -m0755 -oroot -groot daemons/lvmetad/lvmetad $PKG/usr/sbin/lvmetad
+install -D -m0644 -oroot -groot man/lvmlockd.8 $PKG/usr/man/man8/lvmlockd.8
+install -D -m0644 -oroot -groot man/lvmlockctl.8 $PKG/usr/man/man8/lvmlockctl.8
+install -D -m0644 -oroot -groot man/lvmetad.8 $PKG/usr/man/man8/lvmetad.8
+
+install -D -m0755 -oroot -groot scripts/lvm2_lvmetad_init_red_hat $PKG/etc/rc.d/rc.lvmetad.new
+
+# Yes, we are that lazy :^)
+install -D -m0755 -oroot -groot scripts/lvm2_lvmetad_init_red_hat $PKG/etc/rc.d/rc.lvmlockd.new
+sed -e "s|metadata|locking|g" \
+ -e "s|lvmetad|lvmlockd|g" \
+ -i $PKG/etc/rc.d/rc.lvmlockd.new
+
+if [ "${CLOBBER_STOCK_BINARY:-no}" = "yes" ]; then
+ install -D -m0755 -oroot -groot tools/lvm $PKG/sbin/lvm
+fi
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a README $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+cat $CWD/README.SLACKWARE > $PKG/usr/doc/$PRGNAM-$VERSION/README.SLACKWARE
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/system/lvm2-lockd/lvm2-lockd.info b/system/lvm2-lockd/lvm2-lockd.info
new file mode 100644
index 0000000000..08029f5009
--- /dev/null
+++ b/system/lvm2-lockd/lvm2-lockd.info
@@ -0,0 +1,10 @@
+PRGNAM="lvm2-lockd"
+VERSION="2.02.154"
+HOMEPAGE="https://www.sourceware.org/lvm2/"
+DOWNLOAD="http://mirrors.slackware.com/slackware/slackware64-14.2/source/a/lvm2/LVM2.2.02.154.tar.xz"
+MD5SUM="c2732c004d9da7d7d0602745490337ca"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="%README% sanlock"
+MAINTAINER="Mario Preksavec"
+EMAIL="mario at slackware dot hr"
diff --git a/system/lvm2-lockd/slack-desc b/system/lvm2-lockd/slack-desc
new file mode 100644
index 0000000000..adf3aa8439
--- /dev/null
+++ b/system/lvm2-lockd/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+lvm2-lockd: lvm2-lockd (LVM in a shared storage environment)
+lvm2-lockd:
+lvm2-lockd: Logical Volume Management (LVM) commands use lvmlockd to coordinate
+lvm2-lockd: access to shared storage.
+lvm2-lockd:
+lvm2-lockd: Homepage: https://www.sourceware.org/lvm2/
+lvm2-lockd:
+lvm2-lockd:
+lvm2-lockd:
+lvm2-lockd:
+lvm2-lockd: